/*
 * Sistemas de Telecomunicacoes 
 *          2014/2015
 */
package calculator;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import javax.swing.JFileChooser;

/**
 *
 * @author lflb@fct.unl.pt
 */
public class Calculator extends javax.swing.JFrame {

    /**
     * Creates new form Calculator
     */
    public Calculator() {
        initComponents();           // Start graphical window
        first_digit= true;          // Waiting for first number
        state= new Calc_State();    // Create object with partial operand
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFileChooser1 = new javax.swing.JFileChooser();
        jTextNumber = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButtonC = new javax.swing.JButton();
        jButtonCE = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jButtonPlus = new javax.swing.JButton();
        jButtonEquals = new javax.swing.JButton();
        jButtonClear = new javax.swing.JButton();
        jToggleButtonFile = new javax.swing.JToggleButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Calculator");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        jTextNumber.setFont(new java.awt.Font("Courier New", 1, 24)); // NOI18N
        jTextNumber.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextNumber.setText("0");
        jTextNumber.setMaximumSize(new java.awt.Dimension(300, 38));
        jTextNumber.setName("1"); // NOI18N
        getContentPane().add(jTextNumber);

        jPanel1.setMaximumSize(new java.awt.Dimension(210, 116));
        jPanel1.setLayout(new java.awt.GridLayout(4, 3));

        jButton1.setText("1");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);

        jButton2.setText("2");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton2);

        jButtonC.setForeground(new java.awt.Color(255, 70, 70));
        jButtonC.setText("C");
        jButtonC.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCActionPerformed(evt);
            }
        });
        jPanel1.add(jButtonC);

        jButtonCE.setForeground(new java.awt.Color(255, 70, 70));
        jButtonCE.setText("CE");
        jButtonCE.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCEActionPerformed(evt);
            }
        });
        jPanel1.add(jButtonCE);

        getContentPane().add(jPanel1);

        jPanel2.setMaximumSize(new java.awt.Dimension(210, 60));
        jPanel2.setLayout(new java.awt.GridLayout(2, 3));

        jButtonPlus.setText("+");
        jButtonPlus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonPlusActionPerformed(evt);
            }
        });
        jPanel2.add(jButtonPlus);

        jButtonEquals.setText("=");
        jButtonEquals.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonEqualsActionPerformed(evt);
            }
        });
        jPanel2.add(jButtonEquals);

        jButtonClear.setText("Clear");
        jButtonClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonClearActionPerformed(evt);
            }
        });
        jPanel2.add(jButtonClear);

        jToggleButtonFile.setFont(new java.awt.Font("Arial", 0, 15)); // NOI18N
        jToggleButtonFile.setForeground(new java.awt.Color(28, 76, 131));
        jToggleButtonFile.setText("ToFile");
        jToggleButtonFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonFileActionPerformed(evt);
            }
        });
        jPanel2.add(jToggleButtonFile);

        getContentPane().add(jPanel2);

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        getContentPane().add(jScrollPane1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Handle button '1'
     */
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        handle_digit("1");
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * Handle button '2'
     */
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        handle_digit("2");
    }//GEN-LAST:event_jButton2ActionPerformed

    /**
     * Handle button 'C'; deletes last digit pressed
     */
    private void jButtonCActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCActionPerformed
        if (jTextNumber.getText().length() > 1) {
            // Remove last digit
            String str= jTextNumber.getText();      // Get the string
            str= str.substring(0, str.length()-1);  // substring from 0 to length-1
            jTextNumber.setText(str);               // Set new string
        } else {
            // Deleted all digits
            first_digit= true;
            jTextNumber.setText("0");
        }
    }//GEN-LAST:event_jButtonCActionPerformed

    /**
     * Handle button 'CE'; resets the calculator state 
     */
    private void jButtonCEActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCEActionPerformed
        state.reset();
        Log("");                // Add an empty line
        first_digit= true;
        jTextNumber.setText("0");
    }//GEN-LAST:event_jButtonCEActionPerformed

    /**
     * Handle button '+'
     */
    private void jButtonPlusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPlusActionPerformed
        calc_number(jTextNumber.getText(), '+');
        first_digit= true;
    }//GEN-LAST:event_jButtonPlusActionPerformed

    /**
     * Handle button '='
     */
    private void jButtonEqualsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonEqualsActionPerformed
        if (calc_number(jTextNumber.getText(), '=')) {
            Log(Long.toString(state.operand()));    // Write the result of the operation
            jTextNumber.setText(Long.toString(state.operand()));    // Update the number
        }
        first_digit= true;      // Wait for first digit of next number
    }//GEN-LAST:event_jButtonEqualsActionPerformed

    /**
     * Handle button "Clear"; clears log text area
     */
    private void jButtonClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonClearActionPerformed
        jTextArea1.setText("");
    }//GEN-LAST:event_jButtonClearActionPerformed

    /**
     * Handle button "ToFile", which controls recording of operations to file
     */
    private void jToggleButtonFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonFileActionPerformed
        if (jToggleButtonFile.isSelected()) {
            if (!start_writing_to_file()) {
                jToggleButtonFile.setSelected(false);
            }
        } else {
            stop_writing_to_file();
        }
    }//GEN-LAST:event_jToggleButtonFileActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        // Main window is closing - close file if it is open
        stop_writing_to_file();
    }//GEN-LAST:event_formWindowClosing

    /** 
     * Write text to the log text area, the command line and the file, if set
     * @param text  message displayed
     */
    public void Log(String text) {
        jTextArea1.append(text+"\n");   // Write to the TextArea
        System.out.println(text);      // Write to the terminal
        if (os != null) {               // If file is open, write to file
            try {
                os.write(text + "\n");
            } catch (IOException ex) {  // Close file, if write failed
                jTextArea1.append("Error writing to file: "+ex+"\n");
                stop_writing_to_file();
            }
        }
    }
    
    /**
     * Start recording operations to a file; Pick a name and open file for writing
     * 
     * @return true if success
     */
    private boolean start_writing_to_file() {
        try {
            // Open FileChooser dialog window and wait for filename selection
            if (jFileChooser1.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
                f= jFileChooser1.getSelectedFile(); // Get the filename selected
                Log("Writing to: "+f+"\n");
                os= new BufferedWriter(new OutputStreamWriter(
                        new FileOutputStream(f), "8859_1")); // Open writing device
                return true;    // Success – writing to file
            }
        }
        catch (Exception e) {   // Error during file selection or opening
            System.err.println("Error selecting output file: "+e);         
        }        
        return false;
    }
    
    /**
     * Stop recording and close file
     */
    private void stop_writing_to_file() {
        try {                
            if (os != null) {   // If the writing device is open
                os.close();     // Close file writing device ...
                os= null;       //  ... and free memory setting references to null
                f= null;
                Log("Stopped writing\n");
            }
        }
        catch (Exception e) {
            // Ignore
            System.err.println("Error: "+e);
        }
    }
    

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (Exception ex) {
            java.util.logging.Logger.getLogger(Calculator.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new Calculator().setVisible(true);
            }
        });
    }

    
    /**
     * Updates the jTextNumber with the additional digit 
     */
    private void handle_digit(String number) {
        if ((state.last_oper() == '=') && first_digit) {
            // If the result from the last addition is not used
            Log("");        // Add empty line to the output
            state.reset();  // Ignore last result
        }
        String str= jTextNumber.getText();      // get the string
        if (first_digit ||str.equals("0")) {    // Ignore leading zeros
            jTextNumber.setText(number);        // Set the string  
        } else {
            jTextNumber.setText(str+number);    // Concatenate digit
        }
        first_digit= false; // The next digit is not the first!
    }
    
    /**
     * Updates the operand variable value with the result of the operation.
     * Returns: true if success or false is error
     */
    private boolean calc_number(String number, char oper) {
        try {
            // Converts 'String' to long
            long value= Long.parseLong(number);
            
            if (state.last_oper() != '=') {
                Log(number);                    // Write number
            }
            Log(Character.toString(oper));             // Write operation  
            return state.push_operation(value, oper);   // Update state
        }
        catch (Exception e) {
            Log("Invalid number: " + e + "\n");
            return false;
        }
    }    
    
    // Variables
    private boolean first_digit;       // If it is the first number of a number
    private Calc_State state;          // Calculation state 
    private File f;                    // File object
        // File writting objects
    private BufferedWriter os;

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButtonC;
    private javax.swing.JButton jButtonCE;
    private javax.swing.JButton jButtonClear;
    private javax.swing.JButton jButtonEquals;
    private javax.swing.JButton jButtonPlus;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextNumber;
    private javax.swing.JToggleButton jToggleButtonFile;
    // End of variables declaration//GEN-END:variables
}
